#include "m_pd.h"
#include<stdio.h>
#include<string.h>
#include<fcntl.h>
#include<limits.h>
#include<unistd.h>

static t_class *gpio_in_class;

typedef struct _gpio_in {
  t_object  x_obj;
  t_int outlet;
  t_int out;
  char buf[1024];
  char value;
  t_symbol *nom;
} t_gpio_in;

static void gpio_in_bang(t_gpio_in *x)
{
  x->out = open(x->buf, O_RDONLY);
  read(x->out, &x->value, 1);

  if(x->value == '0')
  { 
     x->outlet = 0;
  }
  else
  {
     x->outlet = 1;
  }
  close(x->out);

  outlet_float(x->x_obj.ob_outlet, x->outlet);
}

static void *gpio_in_new(t_symbol *nom_arg)
{
  t_gpio_in *x = (t_gpio_in *)pd_new(gpio_in_class);
  x->nom = nom_arg;
  sprintf(x->buf, "/sys/class/gpio/%s/value",x->nom->s_name);
  post(x->buf);
  outlet_new(&x->x_obj, &s_float);

  return (void *)x;
}

void gpio_in_setup(void) {
  gpio_in_class = class_new(gensym("gpio_in"),
        (t_newmethod)gpio_in_new,
        0, sizeof(t_gpio_in),
        CLASS_DEFAULT,
        A_DEFSYMBOL, 0);

  class_addbang(gpio_in_class, gpio_in_bang);
}

