#include "m_pd.h"
#include<stdio.h>
#include<string.h>
#include<fcntl.h>
#include<limits.h>
#include<unistd.h>

static t_class *gpio_out_class;

typedef struct _gpio_out {
  t_object  x_obj;
  t_float test;
  t_int out;
  char buf[1024];
  char buf2[1024]; 
  t_symbol *nom;
} t_gpio_out;

static void gpio_out_float(t_gpio_out *x, t_floatarg g)
{
  x->test = g;
  sprintf(x->buf2, "Floatinput : %f",x->test);
  post(x->buf2);
}

static void gpio_out_bang(t_gpio_out *x)
{
  t_float f = x->i_tgl;
 
  x->out = open(x->buf, O_WRONLY);
  if (x->i_tgl==0) {
  x->i_tgl = 1;
  write(x->out, "1", 1);
  }
  else {
  x->i_tgl = 0;
  write(x->out, "0", 1);
  }
  close(x->out);
  post(x->buf);
  outlet_float(x->x_obj.ob_outlet, f);
}

static void *gpio_out_new(t_symbol *nom_arg)
{
  t_gpio_out *x = (t_gpio_out *)pd_new(gpio_out_class);
  //x->gpio = f;
  x->nom = nom_arg;
  //x->zename = x->nom;
  sprintf(x->buf, "/sys/class/gpio/%s/value",x->nom->s_name);
  x->i_tgl = 1;
  outlet_new(&x->x_obj, &s_float);

  return (void *)x;
}

void gpio_out_setup(void) {
  gpio_out_class = class_new(gensym("gpio_out"),
        (t_newmethod)gpio_out_new,
        0, sizeof(t_gpio_out),
        CLASS_DEFAULT,
        A_DEFSYMBOL, 0);

  class_addfloat(gpio_out_class, gpio_out_float);
}

